=== debian/changelog ===
gmsh (4.1.5+really4.1.3+ds1-1) unstable; urgency=medium

  * [6d62e8c] debian/rules: Do not pass `-DOCC_INC=...` to cmake (Closes: #927808)

 -- Kurt Kremitzki <kurt@kwk.systems>  Wed, 29 May 2019 19:26:44 -0500
